diff -Nru t1lib-grace/T1lib/t1lib/t1set.c t1lib-deb/T1lib/t1lib/t1set.c
--- t1lib-grace/T1lib/t1lib/t1set.c	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1set.c	2007-12-23 07:49:42.000000000 -0800
@@ -1,11 +1,11 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1set.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-05-27
+  ----- Date:        2005-05-01
   ----- Description: This file is part of the t1-library. It contains
                      functions for setting characters and strings of
 		     characters.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001.
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -52,6 +52,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -76,6 +77,12 @@
 extern char *t1_get_abort_message( int number);
 extern struct region *Interior(struct segment *path, int fillrule);
 extern unsigned T1_AA_TYPE32 T1aa_bg;          /* white value */
+
+
+static void T1_ComputeLineParameters( int FontID, int width,
+				      int mode, float size,
+				      int *startx, int *endx,
+				      int *starty, int *endy);
   
   
 
@@ -90,6 +97,99 @@
 
 
 
+/* bin_dump(): Print a binary dump of a byte, short and
+   long variable (used for debug purposes only): */
+static void bin_dump_c(unsigned char value, char space_flag)
+{
+  int i,j;
+  
+  for (i=0;i<=7;i++){
+    if ((j=((value)>>i)&0x01))
+      printf("X");
+    else
+      printf(".");
+  }
+  if (space_flag)
+    printf(" ");
+
+}
+
+static void bin_dump_s(unsigned short value, char space_flag)
+{
+  int i,j;
+
+  if (T1_CheckEndian()){
+    for (i=8;i<=15;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+    for (i=0;i<=7;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+  }
+  else{
+    for (i=0;i<=15;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+  }
+  if (space_flag)
+    printf(" ");
+  
+}
+
+static void bin_dump_l(unsigned long value, char space_flag)
+{
+  int i,j;
+  
+  if (T1_CheckEndian()){
+    for (i=24;i<=31;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+    for (i=16;i<=23;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+    for (i=8;i<=15;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+    for (i=0;i<=7;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+  }
+  else{
+    for (i=0;i<=31;i++){
+      if ((j=((value)>>i)&0x01))
+	printf("X");
+      else
+	printf(".");
+    }
+  }
+  if (space_flag)
+    printf(" ");
+
+}
+
+
+
 /* T1_SetChar(...): Generate the bitmap for a character */
 GLYPH *T1_SetChar( int FontID, char charcode, float size,
 		   T1_TMATRIX *transform)
@@ -98,9 +198,11 @@
   int mode;
   struct region *area;
   struct XYspace *Current_S;
-  int cache_flag=1;
-  int rot_flag=0;
+  int cache_flag    = 1;
+  int rot_flag      = 0;
   unsigned char ucharcode;
+  float strokewidth = 0.0f;
+  volatile int strokeextraflag = 0;
   
   
   FONTSIZEDEPS *font_ptr;
@@ -145,7 +247,7 @@
   glyph.bpp=1;  
   
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i==-1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
@@ -181,18 +283,42 @@
     rot_flag=0;
     cache_flag=1;
   }
+  
+  /* handle stroking stuff */
+  if ( pFontBase->pFontArray[FontID].info_flags & RASTER_STROKED) {
+    /* Stroking requested. If caching is not desired, clear cache_flag.
+       Otherwise, leave it unaffected. */
+    if ( (pFontBase->pFontArray[FontID].info_flags & CACHE_STROKED) == 0 ) {
+      /* filled glyphs are cached, indicate that character is to be rendered
+	 on the fly and not to be cached */
+      strokeextraflag = 1;
+      cache_flag = 0;
+    }
+    strokewidth = pFontBase->pFontArray[FontID].StrokeWidth;
+  }
+  else {
+    /* filling requested. */
+    if ( (pFontBase->pFontArray[FontID].info_flags & CACHE_STROKED) != 0 ) {
+      /* stroked glyphs are cached, indicate that character is to be rendered
+	 on the fly and not to be cached */
+      strokeextraflag = 1;
+      cache_flag = 0;
+    }
+    strokewidth = 0.0f;
+  }
+  
   /* font is now loaded into memory =>
      Check for size: */
-  if ((font_ptr=QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
-    font_ptr=CreateNewFontSize( FontID, size, NO_ANTIALIAS);
+  if ((font_ptr=T1int_QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
+    font_ptr=T1int_CreateNewFontSize( FontID, size, NO_ANTIALIAS);
     if (font_ptr==NULL){
       T1_errno=T1ERR_ALLOC_MEM;
       return(NULL);
     }
   }
   else {/* size is already existent in cache */
-    /* If no rotation, try to get character from cache */
-    if (rot_flag==0){
+    /* If no rotation and no noncached stroking , try to get character from cache */
+    if ( (rot_flag==0) && (strokeextraflag==0) ) {
       /* we don't use the .bits entry to check because in newer releases
 	 also white glyphs (bits=NULL) are allowed. Rather, we check
 	 whether bpp > 0! */
@@ -240,7 +366,8 @@
 		 fontarrayP->pFontEnc,
 		 ucharcode, &mode,
 		 fontarrayP->pType1Data,
-		 DO_RASTER);
+		 DO_RASTER,
+		 strokewidth);
   KillSpace (Current_S);
 
   /* fill the glyph-structure */
@@ -355,6 +482,8 @@
   static int lastno_chars=0;
   float factor;
   long spacewidth;       /* This is given to fontfcnb_string() */
+  float strokewidth = 0.0f;
+  volatile int strokeextraflag = 0;
   
   
   FONTSIZEDEPS *font_ptr;
@@ -467,7 +596,7 @@
   cache_flag=0;
   
   /* First, check for a correct ID */
-  i=CheckForFontID(FontID);
+  i=T1_CheckForFontID(FontID);
   if (i==-1){
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
@@ -507,10 +636,33 @@
     cache_flag=0;
   }
   
+  /* handle stroking stuff */
+  if ( pFontBase->pFontArray[FontID].info_flags & RASTER_STROKED) {
+    /* Stroking requested. If caching is not desired, clear cache_flag.
+       Otherwise, leave it unaffected. */
+    if ( (pFontBase->pFontArray[FontID].info_flags & CACHE_STROKED) == 0 ) {
+      /* filled glyphs are cached, indicate that character is to be rendered
+	 on the fly and not to be cached */
+      strokeextraflag = 1;
+      cache_flag = 0;
+    }
+    strokewidth = pFontBase->pFontArray[FontID].StrokeWidth;
+  }
+  else {
+    /* filling requested. */
+    if ( (pFontBase->pFontArray[FontID].info_flags & CACHE_STROKED) != 0 ) {
+      /* stroked glyphs are cached, indicate that character is to be rendered
+	 on the fly and not to be cached */
+      strokeextraflag = 1;
+      cache_flag = 0;
+    }
+    strokewidth = 0.0f;
+  }
+  
   /* font is now loaded into memory =>
      Check for size: */
-  if ((font_ptr=QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
-    font_ptr=CreateNewFontSize( FontID, size, NO_ANTIALIAS);
+  if ((font_ptr=T1int_QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
+    font_ptr=T1int_CreateNewFontSize( FontID, size, NO_ANTIALIAS);
     if (font_ptr==NULL){
       T1_errno=T1ERR_ALLOC_MEM;
       return(NULL);
@@ -583,7 +735,7 @@
      */
   /* First, ensure that all needed characters are in the Cache; if not,
      generate them */
-  if ((rot_flag==0)){
+  if ( (rot_flag==0) && (strokeextraflag==0) ){
     overallwidth=0;
     for (i=0; i<no_chars; i++) {
       currchar= &(font_ptr->pFontCache[ustring[i]]);
@@ -597,7 +749,8 @@
 			 fontarrayP->pFontEnc,
 			 ustring[i], &mode,
 			 fontarrayP->pType1Data,
-			 DO_RASTER);
+			 DO_RASTER,
+			 strokewidth);
 
 	  /* fill the glyph-structure */
 	  if (mode > 0) {
@@ -969,6 +1122,9 @@
 	endmask = (char) ~(0xFF << ((start+string_glyph.metrics.advanceX) % 8));
 	Target_c= (unsigned char *)(string_glyph.bits +(i*paddedW/8)
 				    + (start / 8));
+	if (!Target_c) {
+	  continue;
+	}
 	j=middle;
 	if (j == 0)
 	  *Target_c++ |= startmask & endmask;
@@ -994,6 +1150,9 @@
 	endmask = (char) ~(0xFF << ((start+string_glyph.metrics.advanceX) % 8));
 	Target_c= (unsigned char *)(string_glyph.bits +(i*paddedW/8)
 				    + (start / 8));
+	if (!Target_c) {
+	  continue;
+	}
 	j=middle;
 	if (j == 0)
 	  *Target_c++ |= startmask & endmask;
@@ -1019,6 +1178,9 @@
 	endmask = (char) ~(0xFF << ((start+string_glyph.metrics.advanceX) % 8));
 	Target_c= (unsigned char *)(string_glyph.bits +(i*paddedW/8)
 				    + (start / 8));
+	if (!Target_c) {
+	  continue;
+	}
 	j=middle;
 	if (j == 0)
 	  *Target_c++ |= startmask & endmask;
@@ -1055,7 +1217,8 @@
 			ustring, no_chars, &mode,
 			fontarrayP->pType1Data,
 			kern_pairs, spacewidth,
-			DO_RASTER);
+			DO_RASTER,
+			strokewidth);
   KillSpace (Current_S);
   
   /* In all cases, free memory for kerning pairs */
@@ -1378,10 +1541,10 @@
 
 /* This function will essentially return the bounding box of the
    line-rule */
-void T1_ComputeLineParameters( int FontID, int mode,
-			       int width, float size,
-			       int *startx, int *endx,
-			       int *starty, int *endy)
+static void T1_ComputeLineParameters( int FontID, int mode,
+				      int width, float size,
+				      int *startx, int *endx,
+				      int *starty, int *endy)
 {
   float position=0.0, thickness=0.0;
   int startx1, startx2, endx1, endx2;
@@ -1902,3 +2065,185 @@
   
   
 }
+
+
+/* T1_SetRect(): Raster a rectangle, whose size is given in charspace units.
+   The resulting glyph does not cause any escapement. */
+GLYPH* T1_SetRect( int FontID, float size,
+		   float width, float height, T1_TMATRIX *transform)
+{
+  int i;
+  int mode;
+  struct region *area;
+  struct XYspace *Current_S;
+  float strokewidth = 0.0f;
+  
+  FONTSIZEDEPS *font_ptr;
+  FONTPRIVATE  *fontarrayP;
+  
+  volatile int memsize=0;
+  LONG h,w;
+  LONG paddedW;
+
+  static GLYPH glyph={NULL,{0,0,0,0,0,0},NULL,1};
+
+
+  /* We return to this if something goes wrong deep in the rasterizer */
+  if ((i=setjmp( stck_state))!=0) {
+    T1_errno=T1ERR_TYPE1_ABORT;
+    sprintf( err_warn_msg_buf, "t1_abort: Reason: %s",
+	     t1_get_abort_message( i));
+    T1_PrintLog( "T1_SetRect()", err_warn_msg_buf,
+	       T1LOG_ERROR);
+    return( NULL);
+  }
+
+  font_ptr = NULL;
+  
+  /* Reset character glyph, if necessary */
+  if (glyph.bits!=NULL){
+    free(glyph.bits);
+    glyph.bits=NULL;
+  }
+  glyph.metrics.leftSideBearing=0;
+  glyph.metrics.rightSideBearing=0;
+  glyph.metrics.advanceX=0;
+  glyph.metrics.advanceY=0;
+  glyph.metrics.ascent=0;
+  glyph.metrics.descent=0;
+  glyph.pFontCacheInfo=NULL;
+  glyph.bpp=1;  
+  
+  /* First, check for a correct ID. */
+  i=T1_CheckForFontID(FontID);
+  if ( i == -1 ) {
+    return NULL;
+  }
+  /* if necessary load font into memory */
+  if ( i == 0 )
+    if ( T1_LoadFont( FontID) )
+      return NULL;
+
+  /* Check for valid size */
+  if (size<=0.0){
+    T1_errno=T1ERR_INVALID_PARAMETER;
+    return(NULL);
+  }
+
+  /* Assign padding value */
+  T1_pad=pFontBase->bitmap_pad;
+  if (pFontBase->endian)
+    T1_byte=1;
+  else
+    T1_byte=0;
+  T1_wordsize=T1_pad;
+
+  if ( i > 0 ) {
+    /* FontID identifies a valid font */
+    fontarrayP = &(pFontBase->pFontArray[FontID]);
+    
+    /* Check for size and create it if necessary */
+    if ((font_ptr=T1int_QueryFontSize( FontID, size, NO_ANTIALIAS))==NULL){
+      font_ptr=T1int_CreateNewFontSize( FontID, size, NO_ANTIALIAS);
+      if (font_ptr==NULL){
+	T1_errno=T1ERR_ALLOC_MEM;
+	return(NULL);
+      }
+    }
+    
+    /* handle stroking stuff */
+    if ( fontarrayP->info_flags & RASTER_STROKED) {
+      strokewidth = pFontBase->pFontArray[FontID].StrokeWidth;
+    }
+    else {
+      strokewidth = 0.0f;
+    }
+  }
+  else {
+    fontarrayP = NULL;
+    strokewidth = 0.0f;
+  }
+  
+  
+  /* Setup an appropriate charspace matrix. Note that the rasterizer
+     assumes vertical values with inverted sign! Transformation should
+     create a copy of the local charspace matrix which then still has
+     to be made permanent. */
+  if ( transform != NULL ) {
+    Current_S = (struct XYspace *) 
+      Permanent(Scale(Transform (font_ptr->pCharSpaceLocal,
+				 transform->cxx, - transform->cxy,
+				 transform->cyx, - transform->cyy),
+		      DeviceSpecifics.scale_x, DeviceSpecifics.scale_y));
+  }
+  else{
+    Current_S = (struct XYspace *)
+      Permanent(Scale(Transform(font_ptr->pCharSpaceLocal,
+				1.0, 0.0, 0.0, -1.0),
+		      DeviceSpecifics.scale_x, DeviceSpecifics.scale_y));
+  }
+  
+  mode=0;
+  area=fontfcnRect( width,
+		    height,
+		    Current_S,
+		    &mode,
+		    DO_RASTER,
+		    strokewidth);
+  KillSpace (Current_S);
+  
+  /* fill the glyph-structure */
+  if ( mode > 0 ) {
+    sprintf( err_warn_msg_buf, "fontfcnRect() set mode=%d", mode);
+    T1_PrintLog( "T1_SetRect()", err_warn_msg_buf, T1LOG_WARNING);
+    T1_errno=mode;
+    return(NULL);
+  }
+  if ( area == NULL ) {
+    T1_PrintLog( "T1_SetRect()", "area=NULL returned by fontfcnRect()", T1LOG_WARNING);
+    T1_errno=mode;
+    return(NULL);
+  }
+  h = area->ymax - area->ymin;
+  w = area->xmax - area->xmin;
+
+  paddedW = PAD(w, T1_pad);
+  
+  if (h > 0 && w > 0) {
+    memsize = h * paddedW / 8 + 1;
+    /* This is for the users copy of the character, for security-reasons
+       the original pointer to the cache area is not used. The entry glyph.bits
+       is free'ed every time this function is called: */
+    glyph.bits = (char *)malloc(memsize*sizeof( char));
+    if ( glyph.bits == NULL ) {
+      T1_errno=T1ERR_ALLOC_MEM;
+      /* make sure to get rid of 'area' before leaving! */
+      KillRegion (area);
+      return(NULL);
+    }
+  }
+  else {
+    h = w = 0;
+    area->xmin = area->xmax = 0;
+    area->ymin = area->ymax = 0;
+  }
+
+  /* Assign metrics */
+  glyph.metrics.leftSideBearing  = area->xmin;
+  glyph.metrics.advanceX   = NEARESTPEL(area->ending.x - area->origin.x);
+  glyph.metrics.advanceY   = - NEARESTPEL(area->ending.y - area->origin.y);
+  glyph.metrics.rightSideBearing = area->xmax;
+  glyph.metrics.descent          = - area->ymax;
+  glyph.metrics.ascent           = - area->ymin;
+
+  
+  if (h > 0 && w > 0) {
+    (void) memset(glyph.bits, 0, memsize);
+    fill(glyph.bits, h, paddedW, area, T1_byte, T1_bit, T1_wordsize );
+  }
+  
+  /* make sure to get rid of 'area' before leaving! */
+  KillRegion (area);
+  
+  return(&glyph);
+}
diff -Nru t1lib-grace/T1lib/t1lib/t1set.h t1lib-deb/T1lib/t1lib/t1set.h
--- t1lib-grace/T1lib/t1lib/t1set.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1set.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1set.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-05-27
+  ----- Date:        2003-01-02
   ----- Description: This file is part of the t1-library. It contains
                      definitions and declarations for t1set.c.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2003.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -32,16 +32,15 @@
 GLYPH *T1_SetString( int FontID, char *string, volatile int len,
 		     long spaceoff, int modflag,
 		     float size, T1_TMATRIX *transform);
+GLYPH* T1_SetRect( int FontID, float size,
+		   float width, float height,
+		   T1_TMATRIX *transform);
 void fill(char *dest, int h, int w,
 	  struct region *area, int byte, int bit,
 	  int wordsize);
 void fillrun(char *p, pel x0, pel x1, int bit);
 GLYPH *T1_CopyGlyph(GLYPH *glyph);
 void T1_DumpGlyph( GLYPH *glyph);
-void T1_ComputeLineParameters( int FontID, int width,
-			       int mode, float size,
-			       int *startx, int *endx,
-			       int *starty, int *endy);
 GLYPH *T1_ConcatGlyphs( GLYPH *glyph1, GLYPH *glyph2,
 			int x_off, int y_off, int modflag);
 void T1_DumpGlyph( GLYPH *glyph);
@@ -55,6 +54,9 @@
 extern GLYPH *T1_SetString( int FontID, char *string, volatile int len,
 			    long spaceoff, int modflag,
 			    float size, T1_TMATRIX *transform);
+extern GLYPH* T1_SetRect( int FontID, float size,
+			  float width, float height,
+			  T1_TMATRIX *transform);
 extern void fill(char *dest, int h, int w,
 		 struct region *area, int byte, int bit,
 		 int wordsize);
@@ -73,15 +75,24 @@
 			       struct XYspace *S, char **ev,
 			       unsigned char index, int *mode,
 			       psfont *Font_Ptr,
-			       int do_raster);
+			       int do_raster,
+			       float strokewidth);
 extern struct region *fontfcnB_string( int FontID, int modflag,
 				       struct XYspace *S, char **ev,
 				       unsigned char *string, int no_chars,
 				       int *mode, psfont *Font_Ptr,
 				       int *kern_pairs, long spacewidth,
-				       int do_raster);
+				       int do_raster,
+				       float strokewidth);
 extern struct region *fontfcnB_ByName( int FontID, int modflag,
 				       struct XYspace *S,
 				       char *charname,
 				       int *mode, psfont *Font_Ptr,
 				       int do_raster);
+extern struct region* fontfcnRect( float width,
+				   float height,
+				   struct XYspace* S,
+				   int* mode,
+				   int do_raster,
+				   float strokewidth);
+
diff -Nru t1lib-grace/T1lib/t1lib/t1subset.c t1lib-deb/T1lib/t1lib/t1subset.c
--- t1lib-grace/T1lib/t1lib/t1subset.c	2002-07-29 13:37:48.000000000 -0700
+++ t1lib-deb/T1lib/t1lib/t1subset.c	2014-03-27 20:23:42.298776009 -0700
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1subset.c 
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-09-09
+  ----- Date:        2005-05-01
   ----- Description: This file is part of the t1-library. It contains
                      functions for subsetting type 1 fonts.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2005.
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -50,6 +50,7 @@
 #include "../type1/spaces.h"
 #include "../type1/util.h"
 #include "../type1/fontfcn.h"
+#include "../type1/paths.h"
 #include "../type1/regions.h"
 
 
@@ -58,6 +59,7 @@
 #include "t1finfo.h"
 #include "t1misc.h"
 #include "t1base.h"
+#include "t1delete.h"
 #include "t1subset.h"
 
 /* Segment header for pfb-files (reminder):
@@ -81,6 +83,7 @@
 #define SEGMENT_EOF         3
 
 
+extern psobj *StdEncArrayP;       /* For accessing StandardEncoding */
 
 static char *charstringP;
 static int  charstringL;
@@ -194,8 +197,6 @@
 
 
 
-/* A function for reading a Type 1 font file. eexec-decryption
-   is done on the fly.  */
 char *T1_SubsetFont( int FontID,
 		     char *mask,
 		     unsigned int flags,
@@ -222,6 +223,7 @@
   char *csdone;  /* stores which charstrings already have been written */
   int currstring_no=0;
   char *charnameP;
+  char charnamebuf[257];
   unsigned char cipher;
   char rdstring[3];
   char ndstring[3];
@@ -236,6 +238,8 @@
   int m=0;
   int n=0;
   int o=0;
+  int p=0;
+  
   
   int notdefencoded=0;
   int stdenc=0;
@@ -245,11 +249,17 @@
   int encrypt=1;      /* 1=ASCII-hex, 2=Binary, 0=None (for debugging) */
   int dindex=0;
   int nocharstrings=0;
+  char encmask[256];  /* Mask after resolving composite characters */
+  T1_COMP_CHAR_INFO* cci = NULL;
 
+  /* variables for checking SEAC's */
+  int qs_num = 0;
+  unsigned char qs_piece1 = 0;
+  unsigned char qs_piece2 = 0;
   
   
   /* Otherwise we would get invalid accesses later */
-  if (CheckForFontID(FontID)!=1) {
+  if (T1_CheckForFontID(FontID)!=1) {
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   } 
@@ -262,13 +272,81 @@
     return(NULL);
   } 
 
+  /* Reset resulting encoding mask */ 
   for ( j=0; j<256; j++) {
-    if (mask[j]!=0) {
-      nocharstrings++;
-    }
+    encmask[j] = 0;
   }
+  
+  /* Build encmask, a mask, where all required elementary character
+     definitions required are tagged. Font internal SEAC definitions
+     are evaluated at first priority, and as a fallback, also user
+     specified composite character data is taken into account.
+  */
+  for ( j=0; j<256; j++) {
+    if ( mask[j] != 0 ) {
+      /* In any case, tag slot j itself */
+      encmask[j] |= 0x01;
+      /* Now check against correctly defined SEAC (Standard
+	 Encoding Accented Character). */
+      if ( (qs_num = T1int_QuerySEAC( FontID, 
+				      j,
+				      &qs_piece1,
+				      &qs_piece2
+				      )) > 1 ) {
+	/* We have a SEAC --> reserve 2 additional slots, 
+	   the basechar and the accent. The index numbers in this case
+	   always refer to to StandardEncoding, which is not necessarily
+	   the font's current encoding. We indicate this by using bit 2
+	   0x2 inverse sign. */
+	encmask[qs_piece1] |= 0x2;
+	encmask[qs_piece2] |= 0x2;
+      }
+      else {
+	/* OK, it is no a SEAC, but we still check against AFM composite character
+	   data definition. This is non-standard, but we give the user the chance
+	   to access all single character definitions in order construct arbitrary
+	   composite characters. */
+	if ( cci != NULL ) {
+	  T1_FreeCompCharData( cci);
+	}
+	cci = T1_GetCompCharData( FontID, j);
+	
+	if ( (cci != NULL) && (cci->numPieces > 1) ) {
+	  /* Tag all components that are required to construct
+	     the composite character j. */
+	  for ( p=0; p<cci->numPieces; p++) {
+	    encmask[cci->pieces[p].piece] |= 0x1;
+	  }
+	}
+      }
+    } /* if ( mask[j] != 0 ) */
+  } /* for ...  mask */ 
 
 
+  /* Inspect encmask, get number of atomic charstrings and check for
+     ".notdef" being encoded. */
+  for ( j=0; j<256; j++) {
+    if ( (encmask[j] & 0x01) != 0 ) {
+      ++nocharstrings;
+      /* Obtain name from current encoding */
+      charnameP=T1_GetCharName( FontID, j);
+    }
+    if ( (encmask[j] & 0x02) != 0 ) {
+      ++nocharstrings;
+      /* Obtain name from StandardEncoding */
+      strncpy( charnamebuf, (StdEncArrayP[j]).data.nameP, (StdEncArrayP[j]).len);
+      charnamebuf[StdEncArrayP[j].len] = '\0';
+      charnameP=charnamebuf;
+    }
+    if ( encmask[j] != 0 ) {
+      
+      if ( strcmp(charnameP, ".notdef") == 0 ) {
+	notdefencoded=1;
+      }
+    }
+  }
+  
+
   /* adjust encrypting type according to flags. Default is ASCII-hex
      encryption because the output may be verbatim inserted into a
      PostScript-file. */
@@ -312,6 +390,7 @@
        ensure that "eexec" does not get split between two reads.
        Otherwise, decryption would not be started. */
     retval=T1Gets(&(filebuf[i]), 1025, ifp);
+    
     i+=retval;
     if ( (dindex==0) && (T1GetDecrypt()>0) ) {
       dindex=i-retval; /* from this point on we have decrypted bytes */
@@ -319,12 +398,27 @@
 	       dindex);
       T1_PrintLog( "T1_SubsetFont()", err_warn_msg_buf,
 		   T1LOG_DEBUG);
-    }  
+    }
+    
+    /* Encoding handling follows.
+       Note: If the font file defines StandardEncoding (as we will check shortly),
+             but the font has been reencoded by t1lib, we enforce reencoding
+	     in any case so that all characters are accessible eventually in
+	     the subset.
+     */
+    if ( pFontBase->pFontArray[FontID].pFontEnc != NULL ) {
+      T1_PrintLog( "T1_SubsetFont()", "Font is reencoded by t1lib, enforcing Reencoding of subset",
+		   T1LOG_DEBUG);
+      /* Set flag to enforce reenocde in case of StandardEncoding */
+      flags |= T1_SUBSET_FORCE_REENCODE;
+      /* Reset flag to enforce reenocde in case of StandardEncoding */
+      flags &= ~T1_SUBSET_SKIP_REENCODE;
+    }
     
-    /* Encoding handling */
     if (strstr( &(filebuf[i-retval]), "/Encoding")!=NULL) {
       if (strstr( &(filebuf[i-retval]), "StandardEncoding")!=NULL) {
 	stdenc=1;
+
 	if ((flags & T1_SUBSET_FORCE_REENCODE)!=0) {
 	  /* we ignore the current line ... */
 	  i-=retval;
@@ -341,8 +435,11 @@
 	}
       }
       else {
-	/* The encoding is explicitly defined in the font file. We skip the
-	   whole definition unless reencoding should be skipped. */
+	/* The encoding is explicitly defined in the font file. We skip copying 
+	   the whole definition because we will reencode the subset later, unless
+	   reencoding should be skipped by means of the flag settings. If the font
+	   has been reencoded by t1lib, we enforce reencoding in order to ensure
+	   that all characters in the subset will be accessible (see above). */
 	stdenc=0;
 	retval=T1Gets(&(filebuf[i]), 1025, ifp);
 	i+=retval;
@@ -370,19 +467,22 @@
       }
       
       /* At this point, if required, the actual encoding definition
-	 follows  */
+	 follows. */
       if ( reencode!=0) {
 	k=0;
+
+	/* Write actually required encoding slots. We only encode the
+	   characters required from the current fonts encoding. Characters
+	   from StandardEncoding required by composite chars are not encoded. */
 	for ( j=0; j<256; j++) {
-	  if (mask[j]!=0) {
+	  if ( (encmask[j] & 0x01) !=0 ) {
 	    charnameP=T1_GetCharName( FontID, j);
 	    i+=sprintf( &(filebuf[i]), "dup %d /%s put\n", j,
 			charnameP);
 	    k++;
-	    if (strcmp(charnameP, ".notdef")==0)
-	      notdefencoded=1;
 	  }
 	}
+
 	/* finish encoding definition */
 	i+=sprintf( &(filebuf[i]), "readonly def\n");
 	sprintf( err_warn_msg_buf, "Encoded %d characters",
@@ -394,7 +494,7 @@
       
     } /* end of    if (...encoding handling...)    */
 
-    /* Extract the names are used for the charstring definitions.
+    /* Extract the names that are used for the charstring definitions.
        We will later need them! */
     if (strstr( &(filebuf[i-retval]), "/RD")!=NULL) {
       sprintf( rdstring, "RD");
@@ -416,12 +516,14 @@
 	       i-dindex);
       T1_PrintLog( "T1_SubsetFont()", err_warn_msg_buf,
 		   T1LOG_DEBUG);
+
       /* if .notdef is not in the encoding mask, we have to reserve
 	 room for the additional charstring .notdef. Note that still
 	 nocharstrings is an upper bound estimation, which is reached
 	 in cases where no characters are encoded more than one time. */
-      if (notdefencoded==0)
-	nocharstrings++;
+      if ( notdefencoded == 0 ) {
+	nocharstrings++; 
+      }
       
       i+=sprintf( &(filebuf[i]), "2 index /CharStrings %d dict dup begin\n",
 		  nocharstrings);
@@ -461,11 +563,20 @@
   /* Now, step through the specifier matrix and write only the
      necessary charstrings. */
   for ( j=0; j<256; j++) {
-    if (mask[j]!=0) {
-      charnameP=T1_GetCharName( FontID, j);
+    if (encmask[j]!=0) {
+      if ( (encmask[j] & 0x01) != 0 ) {
+	/* Obtain name from current encoding */
+	charnameP=T1_GetCharName( FontID, j);
+      }
+      else {
+	/* Obtain name from StandardEncoding */
+	strncpy( charnamebuf, (StdEncArrayP[j]).data.nameP, (StdEncArrayP[j]).len);
+	charnamebuf[StdEncArrayP[j].len] = '\0';
+	charnameP=charnamebuf;
+      }
       if ((currstring_no=locateCharString( FontID, charnameP))==0) {
-	/* This is mysterious, but causes no harm because .notdef
-	   will be substituted */
+	/* Atomic character not found. This is mysterious, but causes no harm
+	   because .notdef will be substituted */
 	sprintf( err_warn_msg_buf, "Could not locate CS ""%s"" for index %d",
 		 charnameP, j);
 	T1_PrintLog( "T1_SubsetFont()", err_warn_msg_buf,
@@ -481,8 +592,8 @@
 	i+=sprintf( &(filebuf[i]), " %s\n", ndstring);
 	csdone[currstring_no-1]=1;
 	sprintf( err_warn_msg_buf,
-		 "Processing of CS ""%s"" for index %d successful (len=%d bytes, line=%d bytes)",
-		 charnameP, j, charstringL, i-k);
+		 "Processing of CS ""%s"" for index %d (EncMaskFlag=0x%X) successful (len=%d bytes, line=%d bytes)",
+		 charnameP, j, encmask[j], charstringL, i-k);
 	T1_PrintLog( "T1_SubsetFont()", err_warn_msg_buf,
 		     T1LOG_DEBUG);
       }
@@ -494,8 +605,17 @@
       }
     }
   }
-  if (csdone!=NULL)
+
+  /* Get rid of temporary data */
+  if (csdone!=NULL) {
     free( csdone);
+    csdone = NULL;
+  }
+  if ( cci != NULL ) {
+    free( cci);
+    cci = NULL;
+  }
+
   /* All charstrings are written. Some PostScript code follows */
   i+=sprintf( &(filebuf[i]),
 	      "end\nend\nreadonly put\nnoaccess put\ndup /FontName get exch definefont pop\nmark currentfile closefile\n");
@@ -639,7 +759,7 @@
 	     tr_len);
     T1_PrintLog( "T1_SubsetFont()", err_warn_msg_buf,
 		 T1LOG_DEBUG);
-    l+=sprintf( &(trailerbuf[l]), linebuf); /* contains the PostScript trailer */
+    l+=sprintf( &(trailerbuf[l]), "%s", linebuf); /* contains the PostScript trailer */
   }
   
   /* compute size of output file */
@@ -785,7 +905,7 @@
 
   static char *charstring=NULL;
   
-  if (CheckForFontID(FontID)!=1) {
+  if (T1_CheckForFontID(FontID)!=1) {
     T1_errno=T1ERR_INVALID_FONTID;
     return(NULL);
   } 
@@ -826,7 +946,7 @@
 int T1_GetlenIV( int FontID)
 {
   
-  if (CheckForFontID(FontID)!=1) {
+  if (T1_CheckForFontID(FontID)!=1) {
     T1_errno=T1ERR_INVALID_FONTID;
     return( -2);
   } 
diff -Nru t1lib-grace/T1lib/t1lib/t1subset.h t1lib-deb/T1lib/t1lib/t1subset.h
--- t1lib-grace/T1lib/t1lib/t1subset.h	2002-01-03 13:15:15.000000000 -0800
+++ t1lib-deb/T1lib/t1lib/t1subset.h	2007-12-23 07:49:42.000000000 -0800
@@ -1,10 +1,10 @@
 /*--------------------------------------------------------------------------
   ----- File:        t1subset.h
   ----- Author:      Rainer Menzner (Rainer.Menzner@web.de)
-  ----- Date:        2001-04-01
+  ----- Date:        2004-12-02
   ----- Description: This file is part of the t1-library. It contains
                      declarations and definitions for t1subset.c.
-  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2001. 
+  ----- Copyright:   t1lib is copyrighted (c) Rainer Menzner, 1996-2004. 
                      As of version 0.5, t1lib is distributed under the
 		     GNU General Public Library Lincense. The
 		     conditions can be found in the files LICENSE and
@@ -49,6 +49,12 @@
 extern int T1Close( FILE *f);
 extern void T1io_reset( void);
 
+extern int T1int_QuerySEAC( int FontID, 
+			    unsigned char index,
+			    unsigned char* piece1,
+			    unsigned char* piece2
+			    );
+
 char *T1_SubsetFont( int FontID,
 		     char *mask,
 		     unsigned int flags,
